﻿namespace EventBus
{
    public interface IBaseEventData
    {
        /// <summary>
        /// 清除所有事件订阅
        /// </summary>
        void Clear();
        /// <summary>
        /// 取消事件订阅
        /// </summary>
        /// <param name="guid">事件标识<see cref="RuntimeMethodHandle.Value"/></param>
        void UnSubscrip(Guid guid);
        /// <summary>
        /// 事件名称
        /// </summary>
        string EventName { get; }
        /// <summary>
        /// 事件hash
        /// </summary>
        string Hash { get; }
    }
}